<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use Schema;
use Auth;
use App\Models\Setting;
use App\Models\Language;
use App\Models\User;
//use App\Models\MyTransaction;
use App\Models\Company;

class IOTUniversalsController extends Controller
{
    const source_folder = 'C:\xampp\htdocs\\';
    const source_folder_name = 'C:\xampp\htdocs\wordpress_iot';
    const storage_device_path = 'C:\\';
    const not_iots = ['company'];
    const properties = ['lead','leadset'];
    public function __construct()
    {
        $this->page_variables = [
                                    'page_title'   =>   Language::trans('Cities Page'),
                                    'return_url' => class_basename($this).'@getIndex',
                                    'edit_link' => class_basename($this).'@getEdit' ,
                                    'view_link' => class_basename($this).'@getView' ,
                                    'delete_link' => class_basename($this).'@getDelete',
                                    'new_file_link' => class_basename($this).'@getNew' 
                                ];

        //$this->middleware('acl', ['only'=>['getIndex','getNew','getEdit','getView','getDelete']]);
        //$this->middleware('auth_admin');
    }

    public function sizeFormat($bytes){
        $kb = 1024;
        $mb = $kb * 1024;
        $gb = $mb * 1024;
        $tb = $gb * 1024;

        if (($bytes >= 0) && ($bytes < $kb)) {
        return $bytes . ' B';

        } elseif (($bytes >= $kb) && ($bytes < $mb)) {
        return ceil($bytes / $kb) . ' KB';

        } elseif (($bytes >= $mb) && ($bytes < $gb)) {
        return ceil($bytes / $mb) . ' MB';

        } elseif (($bytes >= $gb) && ($bytes < $tb)) {
        return ceil($bytes / $gb) . ' GB';

        } elseif ($bytes >= $tb) {
        return ceil($bytes / $tb) . ' TB';
        } else {
        return $bytes . ' B';
        }
    }

    public function getDirectorySize($dir){
            $count_size = 0;
            $count = 0;
            $dir_array = scandir($dir);
              foreach($dir_array as $key=>$filename){
                if($filename!=".." && $filename!="."){
                   if(is_dir($dir."/".$filename)){
                      $new_foldersize = $this->getDirectorySize($dir."/".$filename);
                      $count_size = $count_size+ $new_foldersize;
                    }else if(is_file($dir."/".$filename)){
                      $count_size = $count_size + filesize($dir."/".$filename);
                      $count++;
                    }
               }
         }
    return $count_size;
    }

    public function getModelClass($request_type)
    {
        $not_iots = static::not_iots;
        $model_class = '';
        if(in_array($request_type,$not_iots)){
            $model_class = 'App\\'.str_replace( ' ', '',ucwords(str_replace( '_', ' ', $request_type))).'';

        }else if(in_array($request_type,static::properties)){
            $model_class = 'App\\Property\\'.str_replace( ' ', '',ucwords(str_replace( '_', ' ', $request_type))).'';
        
        }else{
            $model_class = 'App\\Iot\\'.str_replace( ' ', '',ucwords(str_replace( '_', ' ', $request_type))).'';
        }
        //dd($model_class);
        return $model_class;
    }

    public function getWPDashboardLabelData()
    {

        $api = new Api();   
        $door_sensor_id = '24e124141c141557';
        $ds = array();
        $temp = $api->callAPI(Api::setGetDeviceDataUrl($door_sensor_id)) ;
        $ds_res = $this->extraReadingData($temp) ;
        $ds = is_array($temp) ? false :json_decode($temp,true);
        //dd($ds['deviceProfileName']);
        $sensor['door']['state'] =  isset($ds_res['state']) ? $ds_res['state'] : '-';
        $sensor['door']['name'] =  isset($ds['deviceProfileName']) ? $ds['deviceProfileName'] : '-';

        $entrance_sensor = array();
        
        $entrance_sensor_id = '24e124600c124993';
        $temp = $api->callAPI(Api::setGetDeviceDataUrl($entrance_sensor_id));
        $ds = is_array($temp) ? false : json_encode($temp,true);
        //dd($ds->deviceProfileName);
        $ds_res = $this->extraReadingData($temp) ;
      
        
        $sensor['entrance']['in'] =  isset($ds_res['in']) ? $ds_res['in'] : '0';
        $sensor['entrance']['out'] =  isset($ds_res['out']) ? $ds_res['out'] : '0';
        $sensor['entrance']['name'] =  isset($ds['deviceProfileName']) ? $ds['deviceProfileName'] : '-';

        $entrance_sensor_id = '24e124136c225107';
        $temp = $api->callAPI(Api::setGetDeviceDataUrl($entrance_sensor_id));
        $ds_res = $this->extraReadingData($temp) ;
        $ds = is_array($temp) ? false : json_decode($temp,true);
        //dd($ds);
        $sensor['environment']['temperature'] =  isset($ds_res['temperature']) ? $ds_res['temperature'] : '-';
        $sensor['environment']['humidity'] =  isset($ds_res['humidity']) ? $ds_res['humidity'] : '-';
        $sensor['environment']['name'] =  isset($ds['deviceProfileName']) ? $ds['deviceProfileName'] : '-';

        $entrance_sensor_id = '24e124538c019556';
        $temp = $api->callAPI(Api::setGetDeviceDataUrl($entrance_sensor_id));
        $ds_res = $this->extraReadingData($temp) ;
        //dd($temp);
        $ds = is_array($temp) ? false : json_decode($temp, true);
        //dd($ds_res);
        $sensor['environment']['daylight'] =  isset($ds_res['daylight']) ? $ds_res['daylight'] : '-';
        $sensor['environment']['pir'] =  isset($ds_res['pir']) ? $ds_res['pir'] : '-';
        $sensor['environment']['name'] =  isset($ds['deviceProfileName']) ? $ds['deviceProfileName'] : '-';


         $return = array();
         $return['iot_on_off_count'] = ucfirst($sensor['door']['state']);
         $return['iot_temperature'] = $sensor['environment']['temperature'].' ℃' ;
         $return['iot_humidity'] = $sensor['environment']['humidity'].' %RH';
         $return['iot_brightness'] = ucfirst($sensor['environment']['daylight']);
         $return['iot_data_date_range'] = 'Data (2023/01/02 - '.date('Y/m/d',strtotime('now')).')';

         $null_checks = ['iot_on_off_count','iot_temperature','iot_humidity','iot_brightness'];

         foreach($null_checks as $check)
         {
            //echo $return[$check].'<br>';
            if(strpos($return[$check],'-')!==false)
            {
                $this->getWPDashboardLabelData();
            }
         }
        
         return json_encode($return);
    }

    public function getWPLabelData(Request $request)
    {
        //dd($request->all());
        $dev_eui = $request->get('dev_eui') != null ? $request->get('dev_eui') : false;
        //dd($dev_eui);
         
        if($dev_eui == false)
        {
            return 'No dev eui';
        }
        //$door_sensor_id = '24e124141c141557';

        $api = new Api();
        $ds = array();
        $temp = $api->callAPI(Api::setGetDeviceDataUrl($dev_eui)) ;

        $ds_res = $this->extraReadingData($temp) ;
        $ds = is_array($temp) ? false :json_decode($temp,true);

        if(!isset($ds['deviceName']))
        {
            return 'No device name';
        }
        $var_to_read = $this->getDeviceVarsMapper($ds['deviceName']);
        //dd($var_to_read);
        //dd($ds['deviceProfileName']);
        $value =  isset($ds_res[$var_to_read]) ? $ds_res[$var_to_read] : '-';
            
        return $value;

        //$sensor['door']['name'] =  isset($ds['deviceProfileName']) ? $ds['deviceProfileName'] : '-';
    }

    public function getDeviceVarsMapper($device_name){

        $mappers = ['ws301' => 'state'];
        return isset($mappers[$device_name]) ? $mappers[$device_name] : false;
    }


    public function getTestWpConverter()
    {
        $device_id = isset($_GET['dev_eui']) ? $_GET['dev_eui']  : false ;
        if($device_id == false)
        {
            return '';
        }
        $device_id = '24e124136c225107';
        $reading_data = DeviceReading::getByDeviceEui($device_id);
        $summarize_data = $this->getIotSummaryData($reading_data);
        //dd($summarize_data);
        if($summarize_data['status_code'] != 1)
        {
            return '';
        }

        $summarize_data['request_type'] = $_GET['request_type'] != null ? $_GET['request_type']  : false ;
        if($summarize_data == false)
        {
            return '';
        }

        return $this->wpGraphConverter($summarize_data);

    }


    

    public function getTestWpConverterHumidity()
    {
        $device_id = '24e124136c225107';
        $reading_data = DeviceReading::getByDeviceEui($device_id);
        $summarize_data = $this->getIotSummaryData($reading_data);
        //dd($summarize_data);
        if($summarize_data['status_code'] != 1)
        {
            return '';
        }

        $summarize_data['request_type'] = 'humidity';
        $summarize_data['dev_eui'] = $device_id;
        if($summarize_data == false)
        {
            return '';
        }

        return $this->wpGraphConverter($summarize_data);

    }

    public function getTestWpConverterTemperature()
    {
        $device_id = '24e124136c225107';
        $reading_data = DeviceReading::getByDeviceEui($device_id);
        $summarize_data = $this->getIotSummaryData($reading_data);
        //dd($summarize_data);
        if($summarize_data['status_code'] != 1)
        {
            return '';
        }

        $summarize_data['request_type'] = 'temperature';
        $summarize_data['dev_eui'] = $device_id;
        if($summarize_data == false)
        {
            return '';
        }

        return $this->wpGraphConverter($summarize_data);

    }


    public function getTestWpConverterOnOff()
    {
        $device_id = '24e124141c141557';
        $reading_data = DeviceReading::getByDeviceEui($device_id);
        $summarize_data = $this->getIotSummaryData($reading_data);
       
        if($summarize_data['status_code'] != 1)
        {
            return '';
        }
     
        $summarize_data['request_type'] = 'state';
        if($summarize_data == false)
        {
            return '';
        }

        return $this->wpGraphOnOffConverter($summarize_data);

    }

       public function wpGraphConverter($summarize_data)
    {

          //x = date  , y = value
          $request_type = isset($summarize_data['request_type']) ? $summarize_data['request_type'] : false;
          if($request_type == false){
            return '';
          }   

          $device_name = Device::getDeviceNameByDevEui($summarize_data['dev_eui']);
            
          $data = ['name'=>$device_name ,'data' => array()];
          $category = array();
          $r_data = array();
     
          foreach($summarize_data['data']['data'] as $type => $readings)
          {
            //echo $type.'<br>';
            if($type != $request_type){
                continue;
            }
            foreach($readings as $key => $value)
            {
                $new = number_format((float)$value[0], 2, '.', '');
                //echo $key.' : '.$value[0].'<br>';
                array_push($r_data,$new);
                array_push($category,$key);
            }

          }


        $t_data  = [
                        'name' => $device_name ,
                        'data' => $r_data
                    ];
        $final_data = array();
        array_push($final_data , $t_data);

        $return = ['data' => $final_data , 'category' => $category];
          

        return json_encode($return);


    }


    /*return '{"data":[{"name":"Open","data":[0,2,4,5,6,7]},{"name":"Close","data":[0,2,4,5,6,7]}],"category":["2022-12-13","2022-12-18","2022-12-20","2022-12-21","2022-12-22","2022-12-23","2022-12-24","2022-12-25","2022-12-26","2022-12-27","2022-12-28","2022-12-29","2022-12-30"]}';*/
    public function wpGraphOnOffConverter($summarize_data)
    {

          //x = date  , y = value
          $data_mappers = ['Open','Close'];
          $request_type = isset($summarize_data['request_type']) ? $summarize_data['request_type'] : false;
          if($request_type == false){
            return '';
          }   
            
          $data = ['name'=>'Superman','data' => array()];
          $category = array();
          //$category = ['Open','Close'];
          $r_data = array();
          $raw_data = array();
     
          foreach($summarize_data['data']['data'] as $type => $readings)
          {
            //echo $type.'<br>';
            if($type != $request_type){
                continue;
            }
            //dd($readings);
            //process category
            foreach($readings as $key => $value)
            {  
                $cat = substr($key, 0, 10);
                 //dd(date('Y-m-d' ,  strtotime($key)));
                $var = key($value) == 0 ? 'Close' : 'Open';
                $new = $value[0];
                //echo $key.' : '.$value[0].'<br>';
                $raw_data[$cat][$var] = isset($raw_data[$cat][$var]) ? $raw_data[$cat][$var] : array();
                array_push($raw_data[$cat][$var],$new);
                array_push($r_data,$new);
                if(!in_array($cat,$category))
                {
                    array_push($category,$cat);
                }
                
            }

          }
          //dd($raw_data);
          $g_data = array();
          foreach($raw_data as $x_axis => $y_axis_data)
          {
                foreach($data_mappers as $dm)
                {
                    //echo $dm.'<br>';
                    $val = 0 ;
                    if(isset($y_axis_data[$dm]))
                    {
                        $val = count($y_axis_data[$dm]);
                    }
                    $g_data[$dm] = isset($g_data[$dm]) ? $g_data[$dm] : array();
                    array_push( $g_data[$dm] , $val);
                }
                //dd($y_axis_data);
          }
//echo 'Show';
          //dd($g_data);
       
        $final_data = array();
        foreach($g_data as $x_axis => $gd)
        {
            $t_data  = [
                    'name' => $x_axis,
                    'data' => $gd
                ];

            array_push($final_data , $t_data);
        }
       

        $return = ['data' => $final_data , 'category' => $category];
          

        return json_encode($return);


    }

    public function generatePageVariable($request_type)
    {
        $name = ucwords(str_replace('_', ' ', $request_type));
        $this->page_variables = [
                                    'return_url' => '',
                                    //'return_url' => class_basename($this).'@getIndex',
                                    'page_title'   =>   Language::trans( $name.' Page')
                                ];
        return  $this->page_variables;

    }

   

    public function getSymbols()
    {
        $return = ['humidity' => '%RH' , 'temperature' => '℃'];
        return $return;
    }

    
    public function labelMapper($keys)
    {
        $return = array();
        foreach($keys as $key)
        {

        }

        return $return ;
        
    }




    public function getTransaction()
    {
        $page_variables = $this->page_variables;
        $i              =   1;
        $model          =   new Device();
        $cols           =   $model->listing_header();
        $model          =   $model->listing()->paginate(Setting::paginate);
        $is_model_page  = true;
        //return view(Setting::UI_VERSION.'commons.cities.index', compact('model','i','page_variables','cols','is_model_page'));
    }


/*public function getInfo(Request $request)
    {
        $result;
        $fdata = [
                    'status_code'   =>  0,
                    'status_msg'    =>  Language::trans('Data not found.'),
                    'data'   =>  [],
                    ];
   
        if($request->input('id_type') !== null){
       
            $leaf_group_id = Company::get_group_id() == 0 ? ($request->input('leaf_group_id')  != 0 ? $request->input('leaf_group_id')  : 0) : Company::get_group_id() ;    
           
            if(isset($leaf_group_id)){
                $company = new Company();
                $company->set_group_id($leaf_group_id);
            }

            if($request->input('id_type') == 'leaf_product_id'){   
                $result = Product::get_product_by_leaf_id($request->input('product_id'),$leaf_group_id);
            }


        }else{     
            $result = Product::find($request->input('product_id'));    
        }

        if(isset($result)){

            $tax_txt = $result->display_relationed('sale_tax', 'rate');
            $tax_txt = $tax_txt > 0 ? ($tax_txt/100):0;
            $fdata['status_code']   =   1;
            $fdata['status_msg']    =   Language::trans('Data was found.');
            $fdata['data']['description']   =  $result->name;
            $fdata['data']['quantity']      =  1;
            $fdata['data']['uom']           =  $result->display_relationed('uom', 'name');
            $fdata['data']['tax_id']        =  $result->sale_tax_id;
            $fdata['data']['tax_percent']   =  $tax_txt;
            $fdata['data']['tax_txt']       =  $result->getDouble(Setting::gst_calculate($tax_txt, $result->selling_price));
            $fdata['data']['unit_price']    =  $result->getDouble(Setting::gst_amount_calculate($tax_txt, $result->selling_price));
            $fdata['data']['amount']        =  $result->getDouble(($fdata['data']['quantity'] * $fdata['data']['unit_price']) + $fdata['data']['tax_txt']);

        }

        return json_encode($fdata);
    }*/


 
    public function getIndex($request_type)
    {
       
        //dd('xx');
        //request_type = $_GET['request_type'] !== null ? $_GET['request_type'] : 'false';
        //dd($request_type);
        //get class name
        $is_show_action = true;
        $model_class = $this->getModelClass($request_type);

        //get page name
        $page_variables = $this->generatePageVariable($request_type);
        //dd($page_variables);
        $i              =   1;
        $model          =   new $model_class;
        //$model          =   $model_class::all();
        $cols           =   $model->listing_header();
        $model          =   $model->listing()->paginate(Setting::paginate);
        $is_model_page  = true;



        if($request_type == 'lead'){
          
            $lead_variables = Lead::getLeadVariables();
            return view(Setting::UI_VERSION.'iot.leads.index', compact('model','i','page_variables','cols','is_show_action','request_type','lead_variables'));


        }else if($request_type == 'leadset'){

            $lead_sets = LeadSet::all();
            $lead_variables = Lead::getLeadVariables();
            return view(Setting::UI_VERSION.'iot.lead_sets.index', compact('model','i','page_variables','cols','is_show_action','request_type','lead_sets','lead_variables'));
        
        
        }else{
            return view(Setting::UI_VERSION.'iot.layouts.index', compact('model','i','page_variables','cols','is_show_action','request_type'));
        }

        
        
    }

    public function postIndex(Request $request)
    {   
        $lead_data = array();
        $fields = ['name','phone_number','location','occupation'];
        $input =  $request->all();
        //dd($input);
        foreach($fields as $field)
        {
            $$field = explode("\r\n",$input[$field]);
        }

        foreach($fields as $field)
        {
            $index = 0;
            $temp = $$field;
            foreach($$field as $field_item)
            {
                if($field == 'phone_number')
                {
                    $field_item = str_replace('p:+','',$field_item);
                }
                $lead_data[$index][$field] = $field_item;
                 $index ++;
            }
        }
        $data = ['leads' => $lead_data , 'lead_set_name' => $input['lead_set_name']];
        //dd($data);
        Lead::createListing($data);

      
        return redirect()->action('IOTUniversalsController@getIndex', 'lead')
                            ->with(Setting::session_alert_status, 'check')
                            ->with(Setting::session_alert_status, 'success')
                            ->with(Setting::session_alert_msg, Language::trans('Lead was successfully created.'));
    }

    public function getEdit($request_type)
    {
       
        //dd('xx');
        //request_type = $_GET['request_type'] !== null ? $_GET['request_type'] : 'false';
        //dd($request_type);
        //get class name
        $is_show_action = true;
        $model_class = $this->getModelClass($request_type);
        //dd($model_class);
        //get page name
        $page_variables = $this->generatePageVariable($request_type);
        //dd($page_variables);
        $i              =   1;
        $model          =   new $model_class;
        //$model          =   $model_class::all();
        $cols           =   $model->listing_header();
        $model          =   $model->listing()->paginate(Setting::paginate);
        $is_model_page  = true;


        $graph_info = array();
        $device_ids = ['24e124136c225107','24e124141c141557','24e124141c147463','24e124148b495286','24e124535b316056','24e124538c019556','24e124600c124993'];
        foreach($device_ids as $device_id)
        {
            $feeds = DeviceReading::getByDeviceEui($device_id);
            $tg_info = $this->getIotSummaryData($feeds);
            array_push($graph_info , $tg_info);
        }
        //dd($graph_info);
        //$feeds = DeviceReading::getByDeviceEui($device_id);
        //$graph_infox = $this->getIotSummaryData($feeds);

        return view(Setting::UI_VERSION.'iot.iot_widget_setting.form', compact('model','i','page_variables','cols','graph_info','is_show_action'));
        
    }

    public function postEdit(Request $request, $id)
    {
        if (!$model = City::find($id)) {
            return redirect()->action('DashboardsController@getError', 404);
        }
        $errors = $model->validate_form($request->all());
        if ($errors) {
            return redirect()->back()->withInput()->withErrors($errors);
        }
        $model->save_form($request->all());
        return redirect()->action('CitiesController@getEdit', [$id])
                            ->with(Setting::session_alert_status, 'check')
                            ->with(Setting::session_alert_status, 'success')
                            ->with(Setting::session_alert_msg, $model->name.Language::trans(' was successfully updated.'));
    }

    

    public function getNew($request_type)
    {
        //phpinfo();
        //request_type = $_GET['request_type'] !== null ? $_GET['request_type'] : 'false';
        //dd($request_type);
        //get class name
        $is_show_action = true;
        $model_class = $this->getModelClass($request_type);
        //dd($model_class);
        //get page name
        $page_variables = $this->generatePageVariable($request_type);
        //dd($page_variables);

        $i              =   1;
        $model          =   new $model_class;
        //$model          =   $model_class::all();
        $model['source_folder_name'] = static::source_folder_name;
        //dd( $this->getDirectorySize($model['source_folder_name']));
        //dd($model['source_folder_name']);
        //$status = 'ss';
        $status = disk_free_space(static::storage_device_path) - $this->getDirectorySize($model['source_folder_name']) < 0 ? 'No enough space.' : 'Enough space.';

        $source_storage = $this->sizeFormat($this->getDirectorySize($model['source_folder_name']));
        $storage = ['source_storage' => $source_storage, 'device_storage' => $this->sizeFormat(disk_free_space(static::storage_device_path)), 'status' => $status];
        $is_model_page  = true;
        //dd('x_axis');
        $is_project_folder_created = false; 
        $is_db_created = false;

        
        return view(Setting::UI_VERSION.'iot.'.$request_type.'.form', compact('model','i','page_variables','cols','graph_info','is_show_action','request_type','is_db_created','is_project_folder_created','storage'));
        
    }

    public function postNew(Request $request)
    {
        //dd($request->all());
        $input =  $request->all();
        //dd($input['request_type']);
        $request_type = isset($input['request_type']) ? $input['request_type'] : false;
        $model_class = $this->getModelClass($request_type);
        //dd($model_class);
        $model = new $model_class;
        $errors = $model->validate_form($request->all());
        if ($errors) {
            return redirect()->back()->withInput()->withErrors($errors);
        }
        $model->save_form($request->all());

        return redirect()->action('CitiesController@getEdit', [$model->id])
                            ->with(Setting::session_alert_icon, 'check')
                            ->with(Setting::session_alert_status, 'success')
                            ->with(Setting::session_alert_msg, $model->name.Language::trans(' was successfully created.'));
    }

    public function getView($id)
    {
        $page_variables = $this->page_variables;
        if (!$model = City::find($id)) {
            return redirect()->action('DashboardsController@getError', 404);
        }
        $model->country_id = $model->display_relationed('state_id', 'country_id');

        return view(Setting::UI_VERSION.'commons.cities.view', compact('model','page_variables'));
    }

    /*public function getEdit($id)
    {
        $page_variables = $this->page_variables;
        if (!$model = City::find($id)) {
            return redirect()->action('DashboardsController@getError', 404);
        }
        $model->country_id = (old('country_id') ? old('country_id'):$model->display_relationed('state_id', 'country_id'));

        return view(Setting::UI_VERSION.'commons.cities.form', compact('model','page_variables'));
    }

    public function postEdit(Request $request, $id)
    {
        if (!$model = City::find($id)) {
            return redirect()->action('DashboardsController@getError', 404);
        }
        $errors = $model->validate_form($request->all());
        if ($errors) {
            return redirect()->back()->withInput()->withErrors($errors);
        }
        $model->save_form($request->all());
        return redirect()->action('CitiesController@getEdit', [$id])
                            ->with(Setting::session_alert_status, 'check')
                            ->with(Setting::session_alert_status, 'success')
                            ->with(Setting::session_alert_msg, $model->name.Language::trans(' was successfully updated.'));
    }
*/
    public function getDelete($id)
    {
        if (!$model = City::find($id)) {
            return redirect()->action('DashboardsController@getError', 404);
        }
        $temp = $model->name;
        $model->delete();
        return redirect()->action('CitiesController@getIndex')
                            ->with(Setting::session_alert_status, 'check')
                            ->with(Setting::session_alert_status, 'success')
                            ->with(Setting::session_alert_msg, $temp.Language::trans(' was successfully deleted.'));
    }

    public function extraReadingData($temp)
    {
        $return = false;
        if(is_array($temp))
        {
            
            //echo 'Pass :'.json_encode($response).'<br>';
            if(sizeof($temp) == 0){
               //echo 'Size check fail <br>';
              //continue;
              
            }
         }else{
             $ds =  json_decode($temp , true);
             $return = is_string($ds['objectJSON']) ? json_decode($ds['objectJSON'],true) : false ;
         }



         return $return;
    }

    public function getDashboard(Request $request)
    {   
        $index = 1;
        $api = new Api();
        $trans_summary_data = MyTransaction::getTransactionSummary();
      
        $line_chart_data = array();
        $is_model_page  = false;
        $page_variables = $this->page_variables;
        $company            =   new Company();
        // $company            =   $company->self_profile();

        $company = Company::get_model_by_leaf_group_id(Company::get_group_id());
        if (!Auth::check()) {
         
            return redirect()->action('OpencartUsersController@getLogin');
        }

       
        return view(Setting::UI_VERSION.'iot.dashboards.index', compact('index','page_variables','trans_summary_data','line_chart_data'));
    }

    public function getTableData($request_type=null)
    {
        $data = array();
        $request_type = 'device';
        //dd('xx');
        //request_type = $_GET['request_type'] !== null ? $_GET['request_type'] : 'false';
        //dd($request_type);
        //get class name
        $model_class = 'App\\Iot\\'.str_replace( ' ', '',ucwords(str_replace( '_', ' ', $request_type))).'';
        //dd($model_class);
        //get page name
        $page_variables = $this->generatePageVariable($request_type);
        //dd($page_variables);
        $model          =   new $model_class;
        //$model          =   $model_class::all();
        $cols           =   $model->listing_header();
        $model          =   $model->listing()->paginate(Setting::paginate);
        $is_model_page  = true;
        $counter = 1;
        foreach($model as $index => $row)
        {
            $t_data = array(); 
            $included = ['x24e124136c225107','x24e124141c147463','x24e124141c141557','x24e124148b495286','x24e124535b316056','x24e124538c019556','x24e124600c124993'];

            if(isset($row['dev_eui']))
            {
                if(!in_array($row['dev_eui'],$included)){continue;}
            }
            
            array_push($t_data,$counter);                      
            foreach($row->toArray() as $key => $value)
            {

                if(!in_array($key,$cols))
                {
                    continue;
                }
            
                if($key == 'device_profile_id'){
                    continue;
                }      
                                                    

                    if($key == 'dev_eui')
                    {
                            $vars = ['dev_eui','device_name'];
                            $dp = DeviceProfile::getById($row['device_profile_id']);
                            foreach($vars as $var)
                            {
                               $$var = '';
                            }
                            if(isset($dp['name']))
                            {
                                $dev_eui = substr($value,1,strlen($value));
                                $device_name = $dp['name'];
                            }

                            foreach($vars as $var)
                            {
                                array_push($t_data,$$var) ;
                            }
                          

                    }else if($key == 'status')
                    {
                            array_push($t_data , $row->display_status_string($key));
                    }elseif($key != 'user_id' && $key != 'id')
                    {
                            array_push($t_data ,  $value);
                    }
            }
           
            array_push($data,$t_data);                         
            $counter ++;
                                      
        }

        //dd($data);
        $graph_info = array();
        $device_ids = ['24e124136c225107','24e124141c141557','24e124141c147463','24e124148b495286','24e124535b316056','24e124538c019556','24e124600c124993'];

        foreach($device_ids as $device_id)
        {
            $feeds = DeviceReading::getByDeviceEui($device_id);
            $tg_info = $this->getIotSummaryData($feeds);
            array_push($graph_info , $tg_info);
        }

        $headers = array();
        foreach($cols as $col){
            $temp = '';
            if($col == 'device_profile_id'){
                continue;
            }      

            if($col == 'id'){
                $temp = '#';
            }else if($col == 'dev_eui'){
                $temp_cols = ['#','Device Eui','Name'];
                foreach( $temp_cols as $tc)
                {
                    array_push($headers,$tc);
                }
            }else if(str_contains($col, '_id')){
                $temp = Language::trans(ucwords(str_replace('_id', '', $col)));
            
            }else{
                $temp = Language::trans(ucwords(str_replace('_', ' ', $col)));
            }
            

            if($col != 'dev_eui'){
                array_push($headers,$temp);
            }
    
        }

        $t_data  = [
                        'thead' => $headers,
                        'tbody' => $data
                    ];

        $return = ['data' => $t_data];


        return json_encode($return);
        
    }

     public function getDashboardFinalTestingVer(Request $request)
    {   //dd('xx');

        $api    = new LeafAPI();
        $leaf_group_id = isset($_GET['leaf_group_id']) ? $_GET['leaf_group_id'] : Setting::SUNWAY_GROUP_ID;
        $email = isset($_GET['email']) ? $_GET['email'] : false;
        $telephone = isset($_GET['telephone']) ? $_GET['telephone'] : false;

        //$e_result = $api->get_user_profile_by_email($email);
        //dd($e_result);
        //$telephone = '+6013623990';
        if($email != false)
        {
            $session_return = $api->getUserSessionTokenByEmail($email);
        }
      
        if($telephone != false)
        {
            $session_return = $api->getUserSessionTokenByTelephone($telephone);
        }
        //dd($telephone);
        //dd($session_return);

        //echo 'First :'.$session_return['session_token'].'<br>';

        if(!isset($session_return['session_token']))
        {
            dd('User no exist.');
        }

        $this->session_token =  $session_return['session_token'];
        $session_token = isset($session_return['session_token']) ? $session_return['session_token'] : false;


        Company::setGroupId($leaf_group_id);
        if($leaf_group_id != Company::get_group_id())
        {
            Company::setGroupId($leaf_group_id);
        }

        //cho $leaf_group_id.' : '.$this->session_token.'<br>';
       Log::info('---------------------------------Dash zero------------------------------------------');
        Log::info('User session token :'.$this->session_token);
         Log::info('Group id :'.$leaf_group_id.' : get > '.Company::get_group_id());
        Log::info('---------------------------------------------------------------------------');

        ini_set('max_execution_time', 120);
        ini_set('memory_limit', '1024M');
        $default_language  = 'english';
        $rule = $this->getCompanyRules();
        if($rule !=false)
        {//dd('?');
            return $rule;
        }
        $page_variables = $this->page_variables ;
        $company = Company::get_model_by_leaf_group_id($leaf_group_id);
        //dd($company);
        $notice_msg = $company->getPowerMeterMobileAppMsg();
        $company->set_group_id($leaf_group_id);
        Company::setGroupId($leaf_group_id);
        //dd($company->get_group_id());
        //dd($company['power_meter_operational_setting'] );
        $power_meter_operational_setting     =  json_decode($company['power_meter_operational_setting']);
        //dd($power_meter_operational_setting);
        //setcookie(Setting::LABEL_POWER_METER_OPERATIONAL_SETTING, $power_meter_operational_setting);

        if(!isset($power_meter_operational_setting->top_up_min_amount))
        {
            $power_meter_operational_setting->top_up_min_amount = 10;
            $power_meter_operational_setting->top_up_max_amount = 100;
            $company['power_meter_operational_setting'] = json_encode($power_meter_operational_setting);
            $company->save();
        }
        setcookie(Setting::LABEL_POWER_METER_OPERATIONAL_SETTING,  $power_meter_operational_setting->top_up_min_amount );
        $page_variables['logo_photo_path'] = isset($company['logo_photo_path']) ? $company['logo_photo_path'] : '';
        Setting::setCompany($leaf_group_id);
        //$page_title     =   $this->page_title;
        
        if(Company::get_group_id() == 0){
            setcookie(LeafAPI::label_session_token, $this->session_token);
            
        }

        $room ;
        $leaf_api       = new LeafAPI();
        $model          = new User();
        $setting        = new Setting();
        $session_token  =   $this->session_token;
        //echo 'Second :'.$session_token.'<br>';
        //dd(Company::get_group_id());
        $result         =   $leaf_api->get_user_profile($session_token);
        $fdata          =   $leaf_api->get_user_room($session_token);
        //dd($fdata);
        Log::info('---------------------------------------------------------------------------');
        Log::info('User session token :'.$session_token);
        Log::info('User fdata :'.json_encode($fdata));
        Log::info('User data :'.json_encode($result));
        Log::info('---------------------------------------------------------------------------');
//dd($fdata);
       if ($fdata['status_code'] == true) {
        // dd($notice);
            $notice = $notice_msg['no_room_register_msg'][$default_language]  !='' ? $notice_msg['no_room_register_msg'][$default_language] : $this->no_room_register_msg;
            if (isset($fdata['house_room'])) {
                
                foreach ($fdata['house_room'] as $self_room) {
                    if($self_room['id_group'] == Company::get_group_id())
                    {
                        if($self_room['house_room_member_deleted'] == 1){
                            continue;
                        }
                        $room =  $self_room; 
                        break;
                    }
                    
                }

                if(!isset($room)){
                    return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.informations.user_info',compact('session_token','notice','user','page_variables'));
                }

            }else{          
                return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.informations.user_info',compact('session_token','notice','user','page_variables'));
            }
        }else{
            //dd($notice_msg);
            $notice = $notice_msg['no_room_register_msg'][$default_language]  !='' ? $notice_msg['no_room_register_msg'][$default_language] : $this->no_room_register_msg;
            return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.informations.user_info',compact('session_token','notice','user','page_variables'));
        }

        if (!$result['status_code']) {
            $data['status']         = false;
            $data['status_msg']     = $result['error'];
        } else {
            $user = $model->get_or_create_user_account($result);
            Auth::loginUsingId($user->id, true);
            $data['status']         =   true;
            $data['status_msg']     =   'Authorization successfully.';
            setcookie(LeafAPI::label_session_token, $this->session_token);
        }

        /*$actual_link = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        Log::info($actual_link);
        dd('x');*/
        //dd($user);
        //dd($user->getCustomerPowerUsageSummaryId());

        $account_data = CustomerPowerUsageSummary::find($user->getCustomerPowerUsageSummaryId());
        //dd($account_data);
        if(!isset($account_data['id']))
        {
            $account_data = false;

        }else if(isset($fdata['house_room'])){
          // echo json_encode($fdata['house_room'])."<br>";
           //echo json_encode(array_column($fdata['house_room'],'id_house_room'))."<br>";
         //  dd($account_data['leaf_room_id']);
            /*if(!in_array($account_data['leaf_room_id'] , array_column($fdata['house_room'],'id_house_room')))
            {*/
            //if(!in_array($account_data['leaf_room_id'] , $room['id_house_room']))
            if($account_data['leaf_room_id'] !=  $room['id_house_room'])
            {
                $account_data = false;
                $user->removeCurrentRoomFromCustomerSummaryData();
            }
        }
        //echo 'Pass account check <br>';

        //dd($temp_list);
//dd($account_data);
        if($account_data == false || $account_data == null )
        {

            //dd($room);
            $modal;
            //dd($result);
           
            $syn_data_vars = ['id_house_room' => $room['id_house_room'] , 'leaf_id_user' => $result['id_user'] , 'id_house' => $room['id_house']];
            //dd($syn_data_vars);
            //$id_house_room = $room['id_house_room'];
            $is_synchorizing_data = $account_data == false ? true : false;
            $msg_1 = 'Dear '.$result['user_fullname'].', we are sychronizing your '.$room['house_unit'].' room '.$room['house_room_name'].' data.';
            return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.synchronizing_datas.form', compact('session_token','page_variables' ,'company' , 'is_synchorizing_data','power_meter_operational_setting','modal','msg_1','syn_data_vars'));

            /*$account_data = [ 'is_created' => false , 'total_usage_kwh' => '-' ,'total_payable_amount' => '-' ,'total_paid_amount' => '-' ,'total_outstanding_amount' => '-' ,'total_subsidy_amount' => '-','current_credit_amount' => '-' ,'current_balance_kwh' => '-','current_usage_kwh' => '-','current_usage_amount' => '-'];*/

            //$member_detail = $leaf_api->get_user_house_membership_detail_by_leaf_id_user($result['id_user']);
            //$account_data = PowerMeterAccount::getOrCreatePowerMeterAccount($member_detail);

        }else{
       
            $update_account_data = CustomerPowerUsageSummary::find($account_data['id']);
            
            $account_data['current_usage_kwh'] = 0 ;
            $account_data['current_usage_amount'] = 0;
            $account_data->getLatestStatus();      
            $meter_register_model = $account_data->meter_register;

            if(!isset($meter_register_model)){

                //check and repair is data update
                $new_meter_model = MeterRegister::get_meter_register_by_leaf_room_id($account_data['leaf_room_id']);
                //dd($new_meter_model);
                if(isset($new_meter_model['id']))
                {   $update_account_data = CustomerPowerUsageSummary::find($account_data['id']);
                    $update_account_data['meter_register_id'] = $new_meter_model['id'];
                    $update_account_data->save();
                }else{
                    return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.informations.user_info',compact('session_token','notice','user','page_variables'));
                }

                //No meter registered msg
                
            }

        }

        $backend_data = $company->backend_data ;
        $utransaction_listing_to_check = Utransaction::get_user_transaction_by_cpus_id($account_data['id']);
        ///dd($utransaction_listing_to_check);
        foreach ($utransaction_listing_to_check as $utransaction_model)
        {
            //ky : double check for missing payment
             $tm = MeterPaymentReceived::where('utransaction_id','=',$utransaction_model['id'])->first();
             $is_created = isset($tm['id']) ? 'true' : 'false';
             $is_imcomplete_data = false;
             if(isset($tm['id']))
             {
                 foreach(static::mp_non_zero_cols as $col)
                 {
                    if($tm[$col] == 0){
                          $is_imcomplete_data = true;
                    }else{
                          $is_imcomplete_data = false;
                    }

                 }
             }
             if($tm['id'] == 11047)
             {
                //dd($is_imcomplete_data);
                //dd($tm);
             }
             /*$leaf_respond  = $leaf_api->get_check_payment($utransaction_model['leaf_payment_id']);
            dd($leaf_respond);*/
            if($utransaction_model['is_checked'] == false || $is_created == 'false' || $is_imcomplete_data == true)
            {
                /*dd($tm);
                continue;*/
                    /*if($utransaction_model['is_paid'] == false)
                    {*/

                        $leaf_respond  = $leaf_api->get_check_payment($utransaction_model['leaf_payment_id']);
                    
                        /*echo $utransaction_model['id'].'='.$leaf_respond['payment_paid'].'='.$utransaction_model['is_checked'].'='.$is_created.'<br>'; 
                         if($utransaction_model['id'] == 7425)
                         {
                            dd($leaf_respond);
                            dd('Is check :'.$is_created);
                         }
                         continue;*/


                        if(($leaf_respond['payment_paid'] == true && $is_created == 'false') ||  ($leaf_respond['payment_paid'] == true && $is_imcomplete_data == true))
                        {   
                            
                            //echo $utransaction_model['id'].'='.$leaf_respond['payment_paid'].'<br>';
                            //dd('In repair');
                            //continue;
                            MeterPaymentReceived::saveOrUpdateModelByUtransactionModel($utransaction_model ,  CustomerPowerUsageSummary::find(Auth::user()->getCustomerPowerUsageSummaryId()));
                            $power_meter_payment_success_email = json_decode($backend_data['power_meter_payment_success_email'] , true);
                            
                            if(!$utransaction_model['is_send_success_notification'])
                            {
                                $email_response = $leaf_api->send_email(Auth::user()->email, $power_meter_payment_success_email[$default_language]['title'], $power_meter_payment_success_email[$default_language]['content']);
                                if($email_response['status_code'])
                                {
                                    $model['is_send_success_notification'] = true;
                                }
                            }
                           
                      

                            $utransaction_model['is_paid'] = true;

                            
                        }

                $utransaction_model['is_checked'] = true;
                $utransaction_model->save();

            }

        }
        //dd('x');

        $account_data2 = CustomerPowerUsageSummary::find($user->getCustomerPowerUsageSummaryId());
        $monthly_reading_sum = array();
        $update_keys = ['current_balance_kwh', 'total_usage_kwh'  , 'total_payable_amount'  , 'current_usage_kwh'  , 'current_usage_amount' ,'total_paid_amount', 'total_outstanding_amount' ,'current_credit_amount' , 'current_subsidy_amount' ];
        $data = ['current_subsidy_amount'=>0,'current_balance_kwh' => 0, 'total_usage_kwh' => 0 , 'total_payable_amount' => 0 , 'current_usage_kwh' => 0 , 'current_usage_amount' => 0 , 'current_credit_amount' => 0 ,'total_paid_amount' => 0, 'total_outstanding_amount'  => 0,'current_credit_amount'  => 0];
        $reading_listing = array();
        $date_range     = array('date_started' =>  $account_data['check_in_date'] ,'date_ended' =>  date('Y-m-d', strtotime('now')));
        $monthly_cut_off_listing = Setting::get_company_monthly_cut_off_date_range_by_date_started_and_date_ended($date_range['date_started'],$date_range['date_ended']);

        //dd($date_range);
         $user_stay_detail = $leaf_api->get_user_stay_detail_for_twin_room_by_leaf_room_id($account_data['leaf_room_id'] , true );
         //dd('xx');
         //dd($user_stay_detail);
         $room_type = "";
         if(isset($fdata['house_room'])) {
            Log::Info($fdata['house_room']);
            foreach ($fdata['house_room'] as $self_room) {
                $room_type = $self_room['house_room_type'];
                break;
                
            }
         }
         $user_stay_detail['room_type'] = $room_type;
         if(isset($user_stay_detail[0]['start_date']))
         {
            $user_stay_detail['date_range']  = ['date_started' => $user_stay_detail[0]['start_date'] , 'date_ended' => date('Y-m-d' ,strtotime('now'))];
            $user_stay_detail['leaf_room_id'] =  isset( $user_stay_detail[0]['leaf_room_id']) ?  $user_stay_detail[0]['leaf_room_id'] : 0;
         }
        
         
         //dd($user_stay_detail);
         //$temp_list = MeterPaymentReceived::getPaymentByCPUSId($account_data['id']);
         $temp_list = MeterPaymentReceived::get_meter_payment_received_by_leaf_user_start_stay_detail_all_sunmed($user_stay_detail,Company::get_group_id());
        //dd($temp_list);

         //dd(Company::get_group_id());
         //dd($user_stay_detail);
         

        //$temp_list = MeterPaymentReceived::getPaymentByCPUSId($account_data['id']);
         /*echo $leaf_group_id.'<br>';
         echo json_encode($user_stay_detail).'<br>';
         dd($temp_list);
*/
        $subsidy_data = array();
        $payment_data = array();
        $total_payment = 0;
        $total_subsidy = 0;

        $sub_list = MeterPaymentReceived::get_user_subsidy_by_leaf_id_user_and_meter_register_id_and_date_range($user['leaf_id_user'], $account_data['meter_register_id'] , $date_range );

        foreach ($sub_list as $temp_x) {

            if(date('Y-m-d' ,strtotime($temp_x['document_date'])) <= '2021-03-31')
            {
                continue;
            }

            $subsidy_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_subsidy'] = !isset($subsidy_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_subsidy'] ) ? number_format((float)$temp_x['total_amount'], 2, '.', '') : $subsidy_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_subsidy']  + number_format((float)$temp_x['total_amount'], 2, '.', '');
            $total_subsidy += number_format((float)$temp_x['total_amount'], 2, '.', '');
         
        }

        foreach ($temp_list as $temp_x) {
            //dd($temp_list);
            if($account_data['leaf_room_id'] != $temp_x['leaf_room_id'])
            {
                //dd($temp_x);
                continue;
            }
            //Zeroize
            if(date('Y-m-d' ,strtotime($temp_x['document_date'])) <= '2021-03-31')
            {
                continue;
            }
       // echo $temp_x['id'].' : '.$temp_x['total_amount'].'<br>';
            $payment_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_payment'] = !isset($payment_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_payment'] ) ? number_format((float)$temp_x['total_amount'], 2, '.', '') : $payment_data[date( 'Y-m' , strtotime($temp_x['document_date']))]['total_payment']  + number_format((float)$temp_x['total_amount'], 2, '.', '');
            $total_payment += number_format((float)$temp_x['total_amount'], 2, '.', '');
         
        }

        //dd('x');
        $data['total_paid_amount'] = $total_payment;
     
        //dd($monthly_cut_off_listing);
        
        if($room_type == "single")
        {
            $monthly_cut_off_listing = Setting::get_company_monthly_cut_off_date_range_by_date_started_and_date_ended_single($date_range['date_started'],$date_range['date_ended']);

        }
        else// if($room_type == "twin")
        {
            $monthly_cut_off_listing = Setting::get_company_monthly_cut_off_date_range_by_date_started_and_date_ended($date_range['date_started'],$date_range['date_ended']);
        }


        foreach($monthly_cut_off_listing as $monthly_cut_off){

            $temp = MeterReading::get_daily_meter_reading_by_meter_register_id($meter_register_model->id,$monthly_cut_off);
            //echo $monthly_cut_off['date_started'].':'.(is_array($temp) ? count($temp) : '0').'<br>';
            if($temp !== 0)
            {
                //dd($temp);
                //echo $monthly_cut_off['date_started'].'<br>';
                foreach ($temp as $row) {
                     array_push($reading_listing , $row);
                     //echo 'Push success <br>'.count($reading_listing);
                }
               
            }else{

                if(date('Y-m-d' ,strtotime($monthly_cut_off['date_ended'])) >= date('Y-m-d' ,strtotime('now')))
                {  
                    //echo 'Fail :'.$monthly_cut_off['date_started'].'<br>';     
                    continue;
                }else{
                    //echo 'Pass :'.$monthly_cut_off['date_started'].'<br>';
                }

                $null_data = new MeterReading();
                $null_data['created_at'] = date('Y-m-d' ,strtotime($monthly_cut_off['date_started']));
                $null_data['meter_register_id'] = $account_data['meter_register_id'] ;
                $null_data['leaf_group_id'] = $leaf_group_id;
                $null_data['total_usage'] = 0;
                //echo  json_encode($null_data).'<br>';
                array_push($reading_listing , $null_data);
                //dd($reading_listing);
                //echo 'Push success <br>'.count($reading_listing);
            }
            
            
        }
        //dd($reading_listing);
         foreach($reading_listing as $reading_data){


            $monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['total_usage_kwh'] = !isset($monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['total_usage_kwh'] ) ?  $reading_data->total_usage : $monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['total_usage_kwh']  + $reading_data->total_usage;

            $monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['date'] =  date( 'Y-m' , strtotime($reading_data->created_at));

            $monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['total_payable_amount'] = Setting::calculate_utility_fee($monthly_reading_sum[date( 'Y-m' , strtotime($reading_data->created_at))]['total_usage_kwh']);


            if(date('Y-m', strtotime($reading_data['created_at'])) == date('Y-m', strtotime('now'))){
                $data['current_usage_kwh'] += $reading_data->total_usage;              
            }
            //dd($reading_data);
            //Zeroize
            if(date('Y-m-d' ,strtotime($reading_data['created_at'])) <= '2021-03-31')
            {       
                continue;
            }

            $data['total_usage_kwh'] += $reading_data->total_usage;
            


            


        }
        
        //dd($payment_data);
        //dd($subsidy_data);
       
        //REPAIR missing month
        if( !array_key_exists(date('Y-m', strtotime('now')) , $monthly_reading_sum)) 
        {//dd('No exist');
             $temp = ["total_usage_kwh" => 0, "date" => date('Y-m', strtotime('now')) , "total_payable_amount" => 0];
             $monthly_reading_sum[date('Y-m', strtotime('now'))] = $temp;
        }
         //dd($monthly_reading_sum);

        foreach ($monthly_reading_sum as $month_key => $m_data) {

            if(date('Y-m-d' ,strtotime($month_key.'-01')) <= '2021-03-31')
            {
                continue;
            }

            $monthly_payment = isset($payment_data[$month_key]) ? $payment_data[$month_key]['total_payment'] : 0;
            $monthly_subsidy = isset($subsidy_data[$month_key]) ? $subsidy_data[$month_key]['total_subsidy'] : 0;
            $monthly_reading_sum[$month_key]['total_paid_amount'] = $monthly_payment ;
            $monthly_reading_sum[$month_key]['total_subsidy_amount'] = $monthly_subsidy ;
        }
        //dd($monthly_reading_sum);
        $field_checks = ['total_subsidy_amount','total_payable_amount','total_paid_amount','current_credit_amount'];
        //update the subsidy cal
        foreach ($monthly_reading_sum as $month_key => $m_data) {
            //echo 'Start :'.json_encode($m_data).'<br>';   
            //echo 'Start :'.date('Y-m-d' ,strtotime($month_key.'-01')).'<br>'; 
            if(date('Y-m-d' ,strtotime($month_key.'-01')) <= '2021-03-31')
            {
                continue;
            }
            //echo 'Pass :'.date('Y-m-d' ,strtotime($month_key.'-01')).'<br>';
            foreach ($field_checks as $field_check) {
                 $m_data[$field_check]  =  isset( $m_data[$field_check])?  $m_data[$field_check] : 0;
            }

            $data['current_subsidy_amount'] =  $m_data['total_subsidy_amount'] - $m_data['total_payable_amount'] ;
            //dd($data['current_subsidy_amount']);
            $extra_usage = $data['current_subsidy_amount'] < 0 ? $data['current_subsidy_amount'] * -1  : 0;

            //echo 'Before Current :'.$data['current_credit_amount'].' + '.$m_data['total_paid_amount'].' - '. $extra_usage.'<br>';  

            $data['current_credit_amount'] =   $data['current_credit_amount']  + $m_data['total_paid_amount']  - $extra_usage;

            //echo 'After Current :'.$data['current_credit_amount'].' + '.$m_data['total_paid_amount'].' - '. $extra_usage.'<br>';  
               
            //$data['current_credit_amount'] =  $m_data['total_subsidy_amount'] - $m_data['total_payable_amount'] + $m_data['total_paid_amount'] + $data['current_credit_amount'];
        }
        //dd($data);
        // dd($monthly_reading_sum);

/*        dd($monthly_reading_sum);
dd($data);*/
        
        $data['total_outstanding_amount'] = $data['current_credit_amount'] < 0 ? $data['current_credit_amount'] * -1 : 0;
        $data['total_payable_amount'] = Setting::calculate_utility_fee($data['total_usage_kwh']);
        $data['current_usage_amount'] = Setting::calculate_utility_fee($data['current_usage_kwh']);
        $data['current_balance_kwh'] = Setting::convert_balance_to_kwh_by_current_usage_and_balance(0,$data['current_credit_amount']);
        //dd($data);
        Log::info('Before render :'.json_encode($data));
        foreach ($update_keys as $key) {
           $account_data[$key] = isset($data[$key]) ? $data[$key] : 0;
           $account_data2[$key] = isset($data[$key]) ? $data[$key] : 0;
        }

        Log::info('Data 2 data :'.json_encode($account_data2));
        //dd($account_data2);
        $account_data2->save();
        $house_room_name = Room::getRoomByLeafHouseRoomId($account_data['leaf_house_id'],$account_data['leaf_room_id']);
       //dd($house_room_name);

        //new code  //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
        $user_profile                   = $user;
        //Get statistic 
        $last_reading_model       = MeterRegister::select('last_reading_at')
                                    ->where('id' , '=' , $meter_register_model['id'])
                                    ->orderBy('created_at', 'desc')
                                    ->first();
                                        //        dd( $last_reading_date_time);
        $account_data['last_meter_reading'] = $last_reading_model['last_reading_at'];
       //dd($account_data);
        //$account_data = ['total_usage_kwh' => 250 ,'total_payable_amount' => 0 ,'total_paid_amount' => 0 ,'total_outstanding_amount' => 0 ,'total_subsidy_amount' => 0 ,'current_credit_amount' => 0 ,'current_balance_kwh' => 0];
        return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.home.index', compact('house_room_name','session_token','status_msg','page_variables','user_profile' ,'company' , 'account_data','power_meter_operational_setting'));
        //return view(Setting::UI_VERSION.'utility_charges.mobile_apps_light.home.index', compact('session_token','status_msg','page_variables','user_profile' , 'last_reading_date_time','company' , 'account_data','power_meter_operational_setting'));
    }

}
