<?php

namespace App\Models;

use DB;
use Schema;
use Config;

use App\Models\Company;
use DateTime;
use PHPExcel;
use PHPExcel_Style_Alignment;
use PHPExcel_Style_Border;
use PHPExcel_Style_Fill;
use PHPExcel_Shared_Font;
use PHPExcel_Worksheet_PageSetup;
use PHPExcel_IOFactory;
use PHPExcel_Settings;
use Doctrine\Inflector\Inflector;
use Doctrine\Inflector\NoopWordInflector;

use Doctrine\Inflector\CachedWordInflector;
use Doctrine\Inflector\RulesetInflector;
use Doctrine\Inflector\Rules\English;


class Setting extends ExtendModel
{
	const lazy_load_item_increment = 20;
	const MOBILE_ICON_PATH		= '/leaf_acconting_mobile/img/icon/';
	const LABEL_STATUS_PROGRESS = 'IN PROGRESS';
    const LABEL_STATUS_APPROVED = 'APPROVED';
	//const LANGUAGE_CODE_ARRY = array(0=> 'English',1=> 'Chinese Simplified',2=> 'Chinese Traditional',3=> 'Malay');
	const LANGUAGE_CODE_ARRY = array('en'=> 'English','cn'=> 'Chinese Simplified','my'=> 'Malay');
	const CODING_LANGUAGE_MAPPERS = array('en'=> 'english','cn'=> 'chinese','my'=> 'malay');
	const USER_ADDRESS_ARR = array('Mr.'=>'Mr.','Ms.'=>'Ms.','Bro'=>'Bro','Encik'=>'Encik','Cik'=>'Cik','Kak'=>'Kak');
	const gender = array('male'=>'Male','female'=>'Female');

	// googlemap API key = AIzaSyAVDf0Zb4J1wRnsMZDTZv4nng9arKWP6oo
	const app_secret 		=	'oo238fj928u99odj92897t81726he87e8712t63183y';
	const cart_label 		=	'leaf_webview_cart';
	const wishlist_label 	=	'leaf_webview_wishlist';
	const update_flag 		=  	false;
	//Payment method
	const PAYMENT_METHOD_IPAY_88_WORD = "iPay88";
	const PAYMENT_METHOD_CASH_WORD = "Cash";
	const PAYMENT_METHOD_MOL_PAY_WORD = "MOLPay";
	const PAYMENT_METHOD_CREDIT_CARD_WORD = "Credit Card";
	const PAYMENT_METHOD_ETF_WORD = "ETF";
	const PAYMENT_METHOD_CHEQUE_WORD = "Cheque";
	const PAYMENT_METHOD_OTHERS_WORD = "Others";

	const PAYMENT_METHOD_IPAY_88 = "ipay88";
	const PAYMENT_METHOD_CASH = "cash";
	const PAYMENT_METHOD_MOL_PAY = "molpay";
	const PAYMENT_METHOD_CREDIT_CARD = "credit_card";
	const PAYMENT_METHOD_ETF = "etf";
	const PAYMENT_METHOD_CHEQUE = "cheque";
	const PAYMENT_METHOD_OTHERS = "other";


	const DATA_TABLE_DEFAULT_RECORD_PER_PAGE	= 100;
	const DOUGNUT_CHART_BALANCE_COLOR_SAFE 		= "#00c0ef";
	const DOUGNUT_CHART_BALANCE_COLOR_ALERT 	= "#00c0ef";
	const DOUGNUT_CHART_BALANCE_COLOR_URGENT 	= "#00c0ef";
	const DOUGNUT_CHART_USAGE_COLOR 			= "#ff5959";
	const DOUGNUT_CHART_BALANCE_COLOR 			= "#23d806";
	const DOUGNUT_CHART_USAGE_COLOR_SAFE 		= "#3c8dbc";
	const DOUGNUT_CHART_USAGE_COLOR_ALERT 		= "#3c8dbc";
	const DOUGNUT_CHART_USAGE_COLOR_URGENT 		= "#3c8dbc";
	const CHARGING_RATE_200  					= '0.2180' ;
	const CHARGING_RATE_300  					= '0.3340' ;
	const CHARGING_RATE_600  					= '0.5160' ;
	const CHARGING_RATE_900  					= '0.5460' ;
	const CHARGING_RATE_900_ABOVE  				= '0.5710' ;
	const SUNWAY_LOGO_PATH 						= "\img\sunway_logo.png";
	const LATE_PAYMENT_PENALTY					= '0.01';
	const KWTBB_RATE							= '0.0016';
	const DEFAULT_GST_PERCENT					= '0.06';
	const NO_ROOM 								= "NO_ROOM";
	const NO_POWER_METER 						= "NO_POWER_METER";
	const SINGLE_ROOM 							= "Single Room";
	const TWIN_ROOM 							= "Twin Room";
	const AR_PAYMENT_RECEIVED 					= "AR_PAYMENT_RECEIVED";
	const AR_REFUND 							= "AR_REFUND";
	const AR_INVOICE 							= "AR_INVOICE";
	const SP_SETIA_PAYMENT_RECEIVED_WORKFLOW 	= ['Payee detail',/*'Payment type','Deposit To',*/'Trasaction Detail','Payment Detail','Payment Item'/*,'Check Detail'*/,'Confirmation'];
	const SP_SETIA_PAYMENT_RECEIVED_WORKFLOW_MOBILE 		= ['Payee Info And Payment Method','Payment Detail','Transaction Detail'];
	const SP_SETIA_INVOICING_WORKFLOW 						= ['Payee detail','Payment type','Deposit To','Payment Detail','Payment Item'];
	const SP_SETIA_PAYMENT_RECEIVED_WORKFLOW_STEP_1_ITEM	=  ['Payee detail','Payment type','Deposit To','Payment Detail','Payment Item','Check Detail'];
	const SP_SETIA_MEMBERSHIP_PAYMENT_RECEIVED_WORKFLOW_MOBILE =  ['1','2','3'];
	const SP_SETIA_PAYMENT_PORTAL_CANCEL_PAYMENT_URL = "";
	const SP_SETIA_PAYMENT_PORTAL_RETURN_PAYMENT_URL = "";
	const SP_SETIA_PRODUCT_PROGRAMME_LABEL = "programme";
	const SP_SETIA_PRODUCT_FACILITY_LABEL = "facility";
	const SP_SETIA_PRODUCT_FEE_TYPE_LABEL = "fee_type";
	const LANGUAGE_MALAY = "Malay";
	const LANGUAGE_ENGLISH = "English";
	const LANGUAGE_CHINESE_TRADITIONAL = "Chinese Traditional";
	const LANGUAGE_CHINESE_SIMPLIFIED = "Chinese Simplified";

	const project_company_id = 1;
	const ky_group_id = 282;
	const SUNWAY_GROUP_ID = 519;
	const SUNWAY_WATERFRONT_GROUP_ID = 519;
	const SUNWAY_GROUP_ID_ARR = [282,519];

	const event_photo_path  = "/img/events/";


	const TURN_OFF_PNG  = "/img/utility_charges/off.png";
	const TURN_ON_PNG  = "/img/utility_charges/on.png";
	const LOADING_GIF  = "/img/loading.gif";
	const UI_VERSION = "_version_01.";
	const UI_VERSION_UI = "_version_02";


	const theme_colors = ['purple' => 'Purple','blue' => 'Blue','cyan' => 'Cyan','green' => 'Green','orange' => 'Orange','blush' => 'Blush'];

	public static function erpMappingTypes()
	{
		return  ['single_table' => 'Single Table','sql' => 'Sql'];
	}
	public static function erpOperationTypes()
	{
		return  ['create' => 'Create','update' => 'Update','delete' => 'Delete'];
	}

	public static function getTables()
	{
		$schemaName = 'smarthome';
		$schemaManager = DB::connection()->getDoctrineSchemaManager($schemaName);
		$result = DB::connection()->select("SHOW TABLES FROM $schemaName");
        // Extract table names from the result
        $tables = array_map('current', json_decode(json_encode($result), true));

        // List all tables in the specified schema
        //$tables = $schemaManager->listTableNames();
        //dd($tables);
        return $tables;
	}

	public static function listColumnsFromQuery($sql, $schemaName = null)
    {
        // If using a specific schema, dynamically set the connection
        if ($schemaName) {
            config(['database.connections.dynamic_schema.database' => $schemaName]);
            DB::purge('dynamic_schema');
        }

        // Execute the provided SQL query to get the result set
        $result = DB::connection('dynamic_schema')->select($sql);

        // Extract column names from the result
        $columnNames = [];

        if (!empty($result)) {
            $firstRow = (array) $result[0]; // Convert the first row to an array
            $columnNames = array_keys($firstRow);
        }

        // $columnNames is an array containing the column names
        return $columnNames;
    }

	public static function getTableColumns($tableName, $schemaName = null)
    {
    	$schemaName = 'smarthome';
        // If using a specific schema, include it in the query
        $schemaClause = $schemaName ? "FROM $schemaName." : '';

        // Execute a raw SQL query to get the column information
        $columns = DB::select("SHOW COLUMNS $schemaClause$tableName");

        // Extract column names from the result
        $columnNames = array_column($columns, 'Field');

        // $columnNames is an array containing the column names
        return $columnNames;
    }

	public static function getPhotoPath($name)
	{
		return '/img/'.$name.'/';
	}

	public static function pluralize($word)
	{
		$inflector = new Inflector(
									    new CachedWordInflector(new RulesetInflector(
									        English\Rules::getSingularRuleset()
									    )),
									    new CachedWordInflector(new RulesetInflector(
									        English\Rules::getPluralRuleset()
									    ))
									);

		//dd( $inflector->pluralize('browser'));
		return $inflector->pluralize($word);
	}


	public static function getCodingLanguageMappers()
	{
		return static::CODING_LANGUAGE_MAPPERS;
	}

	public static function getSystemLanguages()
	{
		return static::LANGUAGE_CODE_ARRY;
	}

	public static function array_msort($array, $cols)
	{
	    $colarr = array();
	    foreach ($cols as $col => $order) {
	        $colarr[$col] = array();
	        foreach ($array as $k => $row) { $colarr[$col]['_'.$k] = strtolower($row[$col]); }
	    }
	    $eval = 'array_multisort(';
	    foreach ($cols as $col => $order) {
	        $eval .= '$colarr[\''.$col.'\'],'.$order.',';
	    }
	    $eval = substr($eval,0,-1).');';
	    eval($eval);
	    $ret = array();
	    foreach ($colarr as $col => $arr) {
	        foreach ($arr as $k => $v) {
	            $k = substr($k,1);
	            if (!isset($ret[$k])) $ret[$k] = $array[$k];
	            $ret[$k][$col] = $array[$k][$col];
	        }
	    }
	    return $ret;

	}

	
	public static function compare_order($a, $b)
	{
	  return strtotime($a['house_room_member_start_date']) - strtotime($b['house_room_member_start_date']);
	}

	public static function asc_key_sort_by_function($array)
	{
		return usort($array, 'static::compare_by_timeStamp');
	}


	public static function compare_by_timeStamp_date_range_date_started($time1, $time2) 
	{ 
	    if (strtotime($time1['date_range']['date_started']) < strtotime($time2['date_range']['date_started'])) 
	        return 1; 
	    else if (strtotime($time1['date_range']['date_started']) > strtotime($time2['date_range']['date_started']))  
	        return -1; 
	    else
	        return 0; 
	} 

	public static function compare_by_timeStamp($time1, $time2) 
	{ 
	    if (strtotime($time1['house_room_member_start_date']) < strtotime($time2['house_room_member_start_date'])) 
	        return 1; 
	    else if (strtotime($time1['house_room_member_start_date']) > strtotime($time2['house_room_member_start_date']))  
	        return -1; 
	    else
	        return 0; 
	} 


	public static function compare_by_timeline($time1, $time2) 
	{ 
	    if (strtotime($time1['timeline_date']) > strtotime($time2['timeline_date'])) 
	        return 1; 
	    else if (strtotime($time1['timeline_date']) < strtotime($time2['timeline_date']))  
	        return -1; 
	    else
	        return 0; 
	}  

	public static function compare_by_created_at($time1, $time2) 
	{ 
	    if (strtotime($time1['created_at']) > strtotime($time2['created_at'])) 
	        return 1; 
	    else if (strtotime($time1['created_at']) < strtotime($time2['created_at']))  
	        return -1; 
	    else
	        return 0; 
	} 

	public static function compare_by_column($item_1, $item_2) 
	{ 

	    if ($item_1['result_type'] > $item_2['result_type']) 
	        return 1; 
	    else if ($item_1['result_type'] < $item_2['result_type'])  
	        return -1; 
	    else
	        return 0; 
	} 

	public static function compare_by_room_name($room1, $room2) 
	{ //echo json_encode($room1)."<br>";
	//cho json_encode($room2)."<br>";
	    if ($room1['house_room_name'] > $room2['house_room_name']) 
	        return 1; 
	    else if ($room1['house_room_name'] < $room2['house_room_name'])  
	        return -1; 
	    else
	        return 0; 
	} 

	public static function asc_key_sort(&$array, $key, $type=null) 
	{
	    $sorter=array();
	    $ret=array();
	    reset($array);

	    foreach ($array as $ii => $va) {
	        $sorter[]=$va[$key];
	    }
	}

	public static function ar_sort($sorter)
	{
	    foreach ($sorter as $ii => $va) {
	        $ret[]=$array[$ii];
	    }

	    return $array=$ret;
	}

	public static function calculate_age($dob, $delimeter=null)
	{ 
		return  $dob == '0000-00-00' ? 0 : floor((time() - strtotime($dob)) / 31556926);
	}


	const CODE_SUNMED_IPAY88 = 'ipay88_sunmed';
	const CODE_SUNMED_WATERFRONT_IPAY88 = 'ipay88_sunwaymonashwaterfront';
	const CODE_MONASH_IPAY88 = 'ipay88_sunwaymonash';
	const CODE_LEAF_IPAY88   = 'ipay88';

	const LABEL_MONASH_IPAY88 = 'Sunway Monash University IPay88 Account';
	const LABEL_SUNMED_IPAY88 = 'Sunmed Residential IPay88 Account';
	const LABEL_SUNMED_WATERFRONT_IPAY88 = 'Sunway Water Front Residential IPay88 Account';
	const LABEL_LEAF_IPAY88   = 'LEAF Default IPay88 Account';

	public static function getModelClass($request_type)
    {
        $model_class = 'App\\Models\\'.str_replace( ' ', '',ucwords(str_replace( '_', ' ', $request_type))).'';
        //dd($model_class);
        return $model_class;
    }

	public static function getPaymentGatewayAccountHolderName($payment_gateway)
	{
		$temp = static::payment_gateway_combobox();
		return $temp[$payment_gateway];
	}

	public static function rating_combobox()
	{
		return ['1' => '1','2' => '2','3' => '3','4' => '4','5' => '5'];
	}

	public static function getWorkingDays()
	{
		return ['monday'=>Language::trans('Monday'),'tuesday'=>Language::trans('Tuesday'),'wednesday'=>Language::trans('Wednesday'),'thursday'=>Language::trans('Thursday'),'friday'=>Language::trans('Friday'),'saturday'=>Language::trans('Saturday'),'sunday'=>Language::trans('Sunday')];
	}



	public static function getJobTypes()
	{
		return ['part_time'=>Language::trans('Part Time'),'full_time'=>Language::trans('Full Time'),/*'faq'=>Language::trans('FAQ'),*/];
	}

	public static function getJobNatures()
	{
		return ['on_site'=>Language::trans('On Site'),'remote'=>Language::trans('Remote')];
	}

	public static function getCategoryType()
	{
		return ['article'=>Language::trans('Article'),'event'=>Language::trans('Event'),'faq'=>Language::trans('FAQ'),'job'=>Language::trans('Job'),/*'faq'=>Language::trans('FAQ'),*/];
	}

	public static function getSocialMedias()
	{
		return ['facebook','twitter','linkedin'];
	}


	public static function status_combobox()
	{
		return [true=>'Yes',false=>'No'];
	}

	public static function payment_gateway_combobox()
	{
		return [static::CODE_SUNMED_IPAY88=>static::LABEL_SUNMED_IPAY88,static::CODE_MONASH_IPAY88=>static::LABEL_MONASH_IPAY88,static::CODE_LEAF_IPAY88=>static::LABEL_LEAF_IPAY88,static::CODE_SUNMED_WATERFRONT_IPAY88=>static::LABEL_SUNMED_WATERFRONT_IPAY88];
	}
	

	public static function get_system_language_array(){

		//return ['english' =>static::LANGUAGE_ENGLISH ,'malay'=>static::LANGUAGE_MALAY,'chinese_simplified'=>static::LANGUAGE_CHINESE_SIMPLIFIED,'chinese_traditional'=>static::LANGUAGE_CHINESE_TRADITIONAL];
		return ['english' =>static::LANGUAGE_ENGLISH ,'malay'=>static::LANGUAGE_MALAY,'chinese'=>static::LANGUAGE_CHINESE_SIMPLIFIED];
	}

	public static function get_user_address_array(){

		return static::USER_ADDRESS_ARR;
	}

	public static function getGenderCombo(){

		return static::gender;
	}


	public static  function set_dynamic_connection($schema_name=null)
    {
    	$schema_name = isset($schema_name) ? $schema_name :   'mysql';
        DB::setDefaultConnection($schema_name);
    }

	public static function get_notification_by_leaf_group_id($leaf_group_id=null)
	{
		$leaf_group_id = Setting::get_leaf_group_id($leaf_group_id);
		$company = Company::getModelByLeafGroupId($leaf_group_id);
		$selected_module = json_decode($company['selected_module']);
		$notification_array = array();
		$msg = "";
		$temp_counter = 0;


		if($temp_counter = Customer::get_today_new_record() > 0){
			$msg = $temp_counter.' '.Language::trans("customer record(s) created.");
			array_push($notification_array, $msg);
		}

		if(isset($selected_module)){
			if(count($selected_module) > 0){
				
				foreach ($selected_module as $module) {
					
			

				
				}
			}
		}
		

		return $notification_array;

	}

	//Here to manage of Common UI data formation

	/*
    |--------------------------------------------------------------------------
    | Here to manage of comobobox element
    |--------------------------------------------------------------------------
    |
    */
	
	

    /*
    |--------------------------------------------------------------------------
    | Here to manage of comobobox element
    |--------------------------------------------------------------------------
    |
    */
	public static function costing_method()
	{
		return [''=>'Please select costing method...','fifo'=>'FIFO','standard'=>'Standard','average'=>'Average'];
	}

	public static function payment_received_type()
	{
		return [''=>'Payment received type...','invoice_receipt'=>'Invoice Receiept','security_deposit'=>'Security Deposit'];
	}

	public static function payment_method()
	{
		return [''=>'Payment method...','cheque'=>'Cheque','credit_card'=>'Credit card' , 'cash'=>'Cash' , 'eft'=> 'EFT' , 'others' => 'Others'];
	}

	public static function convert_payment_method_to_ncl_payment_method($payment_method)
	{
		return str_replace('_', ' ', ucwords($payment_method));
	}

	public static function bank_or_cash_combobox(){
		
		$NclApi = new NclAPI();
		$array = array();
		$listing = $NclApi->get_bank_account_list();
		 foreach ($listing['listing'] as $key => $value) {
			$item = $value['code'].'   '.$value['name'];
			$array[$value['code']] = $item;
			//array_push($array , $item);
        }

		return json_decode(json_encode($array)) ;
	}

	public static function gl_account_combobox(){
		
		$NclApi = new NclAPI();
		$array = array();
		$listing = $NclApi->get_gl_account_list();
		 foreach ($listing['listing'] as $key => $value) {
			$item = $value['code'].'   '.$value['name'];
			array_push($array , $item);
        }

		return json_decode(json_encode($array)) ;
	}

	public static function select_days_combobox(){

		$days = [];
		for($i = 1; $i <= 31; $i++){
		    $val = ($i < 10) ? '0'.$i : $i;
		    $days[$val] = $val;
		}

		return $days;
	}

	public static function room_type_combobox()
	{
		return ['single'=>static::SINGLE_ROOM,'twin'=>static::TWIN_ROOM];
	}

    /*
    |--------------------------------------------------------------------------
    | Here to manage of Power Management Element
    |--------------------------------------------------------------------------
    |
    */
    public static function get_month_in_word($month_integer)
    {
    	if($month_integer > 0 && $month_integer <= 12)
    	{
    		$date_object   = DateTime::createFromFormat('!m', $month_integer);
			$month_in_word = $date_object->format('F'); 
			return $month_in_word;
    	}

    	return "";
    }

	public static function photo_place($value)
	{
		if ($value) {
			return $value;
		}
		return 'https://cloud.leaf.com.my/web/images/no_profile.jpg';
	}

	public function convert_encoding($string)
	{
		return $string;
    }
  
	public static function electric_meter_photo()
    {
		return "{{asset('/img/electric_meter.png')}}";
	}

	public static function googlemap_key()
	{
		return 'AIzaSyA9Xcjhr2TvXv7sGzcQXZCrE4pcZ_aDI6w';
	}

	public static function version()
	{
		return '1.3.1.1';
	}

	public static function error_404()
	{
		return 'error 404';
	}

	public static function convert_percentage($percent)
	{
		return 100/str_replace('%', '', $percent);
	}

	public static function gst_calculate($percentage, $amount)
	{
		if (str_contains($percentage, '%')) {
			$percentage = self::convert_percentage($percentage);
		}
		$total = $amount*$percentage;
		if (Company::get_is_inclusive()) {
			$inclu_percentage = 1+$percentage;
			$total = $total/$inclu_percentage;
		}
		return $total;
	}

	public static function gst_amount_calculate($percentage, $amount)
	{
		if (str_contains($percentage, '%')) {
			$percentage = self::convert_percentage($percentage);
		}
		$total = $amount;
		if (Company::get_is_inclusive()) {
			$inclu_percentage = 1+$percentage;
			$total = $total/$inclu_percentage;
		}
		return $total;
	}


    /*
    |--------------------------------------------------------------------------
    | Here to manage of Power management method
    |--------------------------------------------------------------------------
    |
    */
	public static function is_negative($value)
	{
		if (isset($value)){
		    if (substr(strval($value), 0, 1) == "-"){
		   	     return true;
			}else {
			    return false;
			}
		}
	}

 	public static function get_hex_color_code_by_emergency_percent($percent){
 		return '';
 	}

    /*
    |--------------------------------------------------------------------------
    | Here to manage of Report Code
    |--------------------------------------------------------------------------
    |
    */
 	public static function init_php_excelinit_php_excel(){

		PHPExcel_Shared_Font::setAutoSizeMethod(PHPExcel_Shared_Font::AUTOSIZE_METHOD_EXACT);
        PHPExcel_Shared_Font::setTrueTypeFontPath(public_path('fonts/extra/'));    
        //PHPExcel_Settings::setZipClass(PHPExcel_Settings::PCLZIP);  
	}


    /*
    |--------------------------------------------------------------------------
    | Here to manage of Setia work flow element
    |--------------------------------------------------------------------------
    |
    */
 	public static function get_workflow_stepper($work_flow_title_listing){

 		$isFirst = true;
 		$workFlowTitle = $work_flow_title_listing;
 		$workFlowListing = array();
 		foreach($workFlowTitle as $title){
 			$temp['title'] = $title;
 			$temp['status']  = $isFirst == true ? 'done' : '';		
 			array_push($workFlowListing, $temp);
 			$isFirst = false;
 		}


 		return array('work_flow' => $workFlowListing , 'total_step'=>count($workFlowListing));
 	}

 	public static function get_workflow_ui($work_flow_title_listing){

 		$isFirst = true;
 		$workFlowTitle = $work_flow_title_listing;
 		$workFlowListing = array();
 		$counter = 1;
 		foreach($workFlowTitle as $title){
 			$temp['title'] = $title;
 			$temp['step_item'] = static::SP_SETIA_PAYMENT_RECEIVED_WORKFLOW_STEP_1_ITEM;
 			$temp['step_no']  = $counter;
 			array_push($workFlowListing, $temp);
 			$isFirst = false;
 			$counter++;
 		}


 		return array('work_flow' => $workFlowListing , 'total_step'=>count($workFlowListing));
 	}

 	public static function get_sunway_report_title_by_type_and_date_range($type,$date_range =null)
 	{

 		$document_date = $date_range['date_started'].' '.Language::trans('to').' '.$date_range['date_ended'];
 		switch ($type) {
 			case static::SUNWAY_MONTHLY_USAGE_REPORT:
 				$doc = Language::trans('Monthly Usage Report');
 				break;

 			case static::SUNWAY_MONTHLY_SALES_REPORT:
 				$doc = Language::trans('Monthly Sales Report');
 				break;

 			case static::SUNWAY_SALES_REPORT:
 				$doc = Language::trans('Sales Report');
 				break;

 				case static::SUNWAY_ROOM_USAGE_REPORT:
 				$doc = Language::trans('Room Usage');
 				break;
 			
 			default:
 				$doc = Language::trans('Document');
 				break;
 		}

 		return $doc.' ('.$document_date.' )_'.date('Y-m-d', strtotime('now'));
 	}

 	

 	public static function payment_method_to_word($payment_method){

 		$return = "";
 		switch($payment_method){
 			case static::PAYMENT_METHOD_IPAY_88:
 				$return = Language::trans(static::PAYMENT_METHOD_IPAY_88_WORD);
 				break;

			case static::PAYMENT_METHOD_CASH:
				$return = Language::trans(static::PAYMENT_METHOD_CASH_WORD);
				break;

			case static::PAYMENT_METHOD_MOL_PAY:
				$return = Language::trans(static::PAYMENT_METHOD_MOL_PAY_WORD);
				break;

			case static::PAYMENT_METHOD_CREDIT_CARD:
				$return = Language::trans(static::PAYMENT_METHOD_CREDIT_CARD_WORD);
				break;

			case static::PAYMENT_METHOD_ETF:
				$return = Language::trans(static::PAYMENT_METHOD_ETF_WORD);
				break;

			case static::PAYMENT_METHOD_OTHERS:
				$return = Language::trans(static::PAYMENT_METHOD_OTHERS_WORD);
				break;

			case static::PAYMENT_METHOD_CHEQUE:
				$return = Language::trans(static::PAYMENT_METHOD_CHEQUE_WORD);
				break;
			default:
				$return =  null;
				break;
 		}
 		return $return;

 	}

 	public static function credit_card_masking($number, $maskingCharacter="*") {
 		if(strlen($number) < 8){
 			return $number;
 		}
    	return substr($number, 0, 4) . str_repeat($maskingCharacter, strlen($number) - 8) . substr($number, -4);
	}

 	public static function setCompany($id=null){

 		  $c= new Company();
		  $c->set_group_id($id);
		  // /print_r($c::get_group_id());
 	}

 	public static function set_company($id=null){
 		  
 		  $c= new Company();
		  $c->set_group_id($id);
		  // /print_r($c::get_group_id());
 	}

 	public static function number_to_word( $num = '' )
	{
		$numArr = explode('.', $num);
		$numWord = '';
		$isFirst = true;

		foreach ($numArr as $num) {
			$num    = ( string ) ( ( int ) $num );

		if( ( int ) ( $num ) && ctype_digit( $num ) )
		{
			$words  = array( );
		   
			$num    = str_replace( array( ',' , ' ' ) , '' , trim( $num ) );
		   
			$list1  = array('','one','two','three','four','five','six','seven',
				'eight','nine','ten','eleven','twelve','thirteen','fourteen',
				'fifteen','sixteen','seventeen','eighteen','nineteen');
		   
			$list2  = array('','ten','twenty','thirty','forty','fifty','sixty',
				'seventy','eighty','ninety','hundred');
		   
			$list3  = array('','thousand','million','billion','trillion',
				'quadrillion','quintillion','sextillion','septillion',
				'octillion','nonillion','decillion','undecillion',
				'duodecillion','tredecillion','quattuordecillion',
				'quindecillion','sexdecillion','septendecillion',
				'octodecillion','novemdecillion','vigintillion');
		   
			$num_length = strlen( $num );
			$levels = ( int ) ( ( $num_length + 2 ) / 3 );
			$max_length = $levels * 3;
			$num    = substr( '00'.$num , -$max_length );
			$num_levels = str_split( $num , 3 );
		   
			foreach( $num_levels as $num_part )
			{
				$levels--;
				$hundreds   = ( int ) ( $num_part / 100 );
				$hundreds   = ( $hundreds ? ' ' . $list1[$hundreds] . ' Hundred' . ' ' : '' );
				$tens       = ( int ) ( $num_part % 100 );
				$singles    = '';
			   
				if( $tens < 20 )
				{
					$tens   = ( $tens ? ' ' . $list1[$tens] . ' ' : '' );
				}
				else
				{
					$tens   = ( int ) ( $tens / 10 );
					$tens   = ' ' . $list2[$tens] . ' ';
					$singles    = ( int ) ( $num_part % 10 );
					$singles    = ' ' . $list1[$singles] . ' ';
				}
				$words[]    = $hundreds . $tens . $singles . ( ( $levels && ( int ) ( $num_part ) ) ? ' ' . $list3[$levels] . ' ' : '' );
			}
		   
			$commas = count( $words );
		   
			if( $commas > 1 )
			{
				$commas = $commas - 1;
			}
		   
			$words  = implode( ', ' , $words );
		   
			//Some Finishing Touch
			//Replacing multiples of spaces with one space
			// $words  = trim( str_replace( ' ,' , ',' , trim_all( ucwords( $words ) ) ) , ', ' );
			
			$words = trim($words);
			
			$words  = str_replace( '  ' , ' ' , $words );
			if( $commas )
			{
				if (substr($words, -1) == ',') {
					$words  = str_replace( ' ,' , '' , $words );
				}else{
					$words  = str_replace( ' ,' , ' and' , $words );
				}
				
			}
			
			//return $words;
			if($isFirst == false){
				$numWord = $numWord.' AND '.$words;
			}else{
				$isFirst = false;
				$numWord = $words;
			}
			
		}
		else if( ! ( ( int ) $num ) && count($numArr) == 1 )
		{


			return 'Zero';
		}
		}
		return $numWord;
		//return '';
	}


	public static function strpos_array($haystack, $needle, $offset=0)
	{
	    if(!is_array($needle)) $needle = array($needle);
	    foreach($needle as $query) {
	        if(strpos($haystack, $query, $offset) !== false) return true; // stop on first true result
	    }
	    return false;
	}

	public static function get_leaf_group_id($leaf_group_id=null)
	{
		$leaf_group_id  = $leaf_group_id == '' ? static::ky_group_id : $leaf_group_id;
		return isset($leaf_group_id) ? $leaf_group_id : Company::get_group_id();
	}


	public static function get_date_different_in_day($date_started,$date_ended){

		$start_date = strtotime($date_started); 
		$end_date = strtotime($date_ended); 
		  
		// Get the difference and divide into  
		// total no. seconds 60/60/24 to get  
		// number of days 
		return ($end_date - $start_date)/60/60/24; 
	}

	public static function date_differrent($time1, $time2, $precision = 6) 
	{
	    // If not numeric then convert texts to unix timestamps
	    if (!is_int($time1)) {
	      $time1 = strtotime($time1);
	    }
	    if (!is_int($time2)) {
	      $time2 = strtotime($time2);
	    }

	    // If time1 is bigger than time2
	    // Then swap time1 and time2
	    if ($time1 > $time2) {
	      $ttime = $time1;
	      $time1 = $time2;
	      $time2 = $ttime;
	    }

	    // Set up intervals and diffs arrays
	    $intervals = array('year','month','day','hour','minute','second');
	    $diffs = array();

	    // Loop thru all intervals
	    foreach ($intervals as $interval) {
	      // Create temp time from time1 and interval
	      $ttime = strtotime('+1 ' . $interval, $time1);
	      // Set initial values
	      $add = 1;
	      $looped = 0;
	      // Loop until temp time is smaller than time2
	      while ($time2 >= $ttime) {
	        // Create new temp time from time1 and interval
	        $add++;
	        $ttime = strtotime("+" . $add . " " . $interval, $time1);
	        $looped++;
	      }
	 
	      $time1 = strtotime("+" . $looped . " " . $interval, $time1);
	      $diffs[$interval] = $looped;
	    }
	    
	    $count = 0;
	    $times = array();
	    // Loop thru all diffs
	    foreach ($diffs as $interval => $value) {
	      // Break if we have needed precission
	      if ($count >= $precision) {
	        break;
	      }
	      // Add value and interval 
	      // if value is bigger than 0
	      if ($value > 0) {
	        // Add s if value is not 1
	        if ($value != 1) {
	          $interval .= "s";
	        }
	        // Add value and interval to times array
	        $times[] = $value . " " . $interval;
	        $count++;
	      }
	    }

	    // Return string with times
	    return implode(", ", $times);
  }

  public static function convert_to_unix_timestamp($datetime)
  {
  	return strtotime($datetime);
  }

  public static function convert_to_unix_timestamp_to_date_time($unix_timestamp)
  {
	return gmdate("Y-m-d\ T H:i:s\ Z" , $unix_timestamp);
  }

  public static function convert_to_unix_timestamp_to_date_time_2($unix_timestamp)
  {
	$date_time = new DateTime();
	$date_time = DateTime::createFromFormat( 'U', $unix_timestamp );
	$return = $date_time->format( 'Y-m-d' );
	return $return;
  }
  

  public static function convert_date_range_string_to_array($date_range_string){
  
   $date_range_arr = explode('-', $date_range_string);
   $date_range = [
				   'date_started' =>  date("Y-m-d", strtotime($date_range_arr[0])),
				   'date_ended' =>  date("Y-m-d", strtotime($date_range_arr[1])),
				   ];

  	return $date_range;
  }

  public static function fix_serialize_data($bad_data){
  	$fixed_data = preg_replace_callback ( '!s:(\d+):"(.*?)";!', function($match) {      
                        return ($match[1] == strlen($match[2])) ? $match[0] : 's:' . strlen($match[2]) . ':"' . $match[2] . '";';
                    },$bad_data );
  }

  public static function get_array_element_with_column_and_value($model_listing, $column, $value)
  {
  	//dd($model_listing);
	//echo $column.'='.$value."<br>";
  	foreach ($model_listing as $model) {
                if($model[$column] == $value ){
                    return $model;
                }
    }

    return null;
  }


  public static function remove_invalid_array_element_with_model_listing_and_column($column_array, $model_listing, $column)
  {
  	foreach ($model_listing as $model) {
                if(in_array($model[$column] , $column_array )){
                    //search delete value
                    if (($key = array_search($model[$column], $column_array)) !== false) {
                        unset($column_array[$key]);
                    }
                }
    }

    return $column_array;
  }

  public static function base64_to_jpeg($base64_string, $output_file) 
  {
		    // open the output file for writing
		    $ifp = fopen( $output_file, 'wb' ); 

		    // split the string on commas
		    // $data[ 0 ] == "data:image/png;base64"
		    // $data[ 1 ] == <actual base64 string>
		    $data = explode( ',', $base64_string );

		    // we could add validation here with ensuring count( $data ) > 1
		    fwrite( $ifp, base64_decode( $data[ 1 ] ) );

		    // clean up the file resource
		    fclose( $ifp ); 

		    return $output_file; 
	}

  const power_meter_site_url = 'http://webview.leaf.com.my/utility_adjustment_check_by_email_second?email=';
  public static function generate_power_meter_testing_barcode_url($user_email)
  {
  	 return static::power_meter_site_url.$user_email;
  }

  public static function mail_engine()
  {
  		return ['smptp'=> 'SMTP' , 'mail' => 'Mail'];
  }

  public static function getIp(){
    foreach (array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key){
        if (array_key_exists($key, $_SERVER) === true){
            foreach (explode(',', $_SERVER[$key]) as $ip){
                $ip = trim($ip); // just to be safe
                if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE) !== false){
                    return $ip;
                }
            }
        }
    }
  }

  public static function month_year_combobox($total_year=1)
    {
        $total_months = $total_year * 12;
        $start = 0 - $total_months/3;
        $end = $total_months/3;
        for ($i=$start; $i<=$end; $i++) { 
        	//dd($i);
            $action = $i < 0 ? '- '.abs($i) : '+ '.$i;
            $string = date('m-Y', strtotime($action.' month'));
            $return[(string) $string] = (string) $string;
        }
        return $return;
    }

    public static function date_sort($a, $b) {
	    return strtotime('01-'.$a) - strtotime('01-'.$b);
	}

	public static function sortByDateColumn( $model_listing,$column_name=null)
	{
		$keys = array_keys($model_listing);
		usort($keys, "App\Setting::date_sort");

		$return = array();
		foreach($keys as $key)
		{
			$return[$key] = isset($model_listing[$key]) ? $model_listing[$key] : array();
		}
		return $return;
	}

	public function setCookie($value,$name){
      $minutes = 60000;
      cookie($name, $value, $minutes);
   }

   	public static function getIntervalInMinutes($interval)
   	{
		$intervalInSeconds = (new DateTime())->setTimeStamp(0)->add($interval)->getTimeStamp();
		$intervalInMinutes = $intervalInSeconds/60; // and so on
		return $intervalInMinutes;
   	}

   	public static function get_transaction_type_by_description($description){

 		 	$model = new MyTransaction();
 			//$model = array();
 		 	$temp = explode(" ", $description);
			$reference_no_counter = 0 ;
			$bank_no_counter = 0 ;
			$temp_description = "";
			$i = 0 ;
			$next_to_description = false;
		
 		 	//dd(strpos($description,'TSFR FUND CR-ATM/EFT') !==  false);
 			if(strpos($description,'CR-ATM/EFT') !== false){

				$model['transaction_type'] = 'Transfer';
				$model['flow'] = 'Debit';

			}else if(strpos($description,'TSFR FUND DR-ATM/EFT') !== false){

				$model['transaction_type'] = 'Transfer';
				$model['flow'] = 'Credit';

			}else if(strpos($description,'TSFR FUND CR-ATM/EFT') !== false){

				$model['transaction_type'] = 'Transfer';
				$model['flow'] = 'Debit';


			}else if(strpos($description,'HANDLING CHRG') !== false){

				$model['transaction_type'] = 'Transfer Charge';
				$model['flow'] = 'Credit';

			}else if(strpos($description,'INT CR-INT CYCLE') !== false){

				$model['transaction_type'] = 'Cycle';
				$model['flow'] = 'Debit';

			}else if(strpos($description,'DEP-CASH') !== false){

				$model['transaction_type'] = 'Deposit Cash';
				$model['flow'] = 'Debit';

			}else if(strpos($description,'DEP-ECP') !== false){

		 		$model['transaction_type'] = 'Deposit';
		 		$model['flow'] = 'Debit';

			}else if(strpos($description,'PB LIFESTYLE DR') !== false){

		 		$model['transaction_type'] = 'Transfer';
		 		$model['flow'] = 'Credit';

			}else if(strpos($description,'GST DR') !== false){

		 		$model['transaction_type'] = 'Transfer Charge';
		 		$model['flow'] = 'Credit';

			}else{ 
			}
			//echo "<br>";
			//echo nl2br($return);
			//print_r($return);

			foreach ($temp as $desc_item) {
				if($desc_item == 'NO:')
				{
					$reference_no_counter = $i + 1;
					$bank_no_counter = $i + 2; 
					$next_to_description = true;

				}	
			 	$i++;
			}

			$model['reference_no'] = $temp[$reference_no_counter];
			$model['account_no'] = count($temp) == $bank_no_counter ? $temp[$bank_no_counter-1] : $temp[$bank_no_counter];
			$model['bank_slip_description'] = $description;
			$model['description'] = $description;
		
			return $model;
	}

}		




