@extends('_version_01.iot.layouts.admin')
@section('content')
{!! Form::model($model, ['class'=>'form-horizontal','files'=>true, 'enctype'=>'multipart/form-data','method' => 'post']) !!}
@include('_version_01.iot.layouts.partials._alert')
@include('_version_01.iot.layouts.partials._request_type')

@php
    $listing = App\Models\Testimony::all();
@endphp
<div class="row clearfix">
            <div class="col-md-12">
                <div class="card">
                    <div class="header">
                        <h2><strong>Testimony</strong> </h2>      
                    </div>
                    <div class="body">
                            <div class="row">
                                <div class="col-md-12">
                                    
                                    <div class="table-wrap">
                                        <div class="table-responsive-md">
                                            <table id="listing_table" class="table table-bordered table-hover">
                                                <thead>
                                                    <tr>
                                                        <th width="50 px;">#</th>
                                                        <th class="text-center"  style='width:10%;'>
                                                            {{App\Models\Language::trans('User Profile Picture')}}
                                                        </th>

                                                         <th class="text-center" style='width:20%;'>
                                                            {{App\Models\Language::trans('Name')}}<br>
                                                            {{App\Models\Language::trans('Job')}}<br>
                                                        </th>

                                                        <th class="text-center" style='width:40%;'>
                                                            {{App\Models\Language::trans('content')}}<br>
                                                        </th>

                                                        <th class="text-center" style='width:10%;'>
                                                            {{App\Models\Language::trans('Rating')}}
                                                            {{App\Models\Language::trans('Sort Order')}}
                                                        </th>


                                                        <th><a style ='margin-bottom:2px;' class="btn btn-success mb-15" onclick="add_row('listing_table');" href="javascript:void(0)"><i class="fa fa-plus-square fa-fw"></i> {{App\Models\Language::trans('Add Row')}}</a></th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                  @foreach($listing as $row)

                                                                @php
                                                                        $content_data_arr = isset($row['id']) ? json_decode($row['content'],true) : array();
                                                                @endphp

                                                                <tr>
                                                                    <td>{{$i}}</td>
                                                                    <td>
                                                                        <input type='file' name='cover_photo_path[{{$i}}]' class='form-control dropify' 
                                                                            @if($row->cover_photo_path != null)
                                                                                 data-default-file={{asset($row->cover_photo_path)}}
                                                                            @endif
                                                                        >

                                                                        @if($row->cover_photo_path != null)
                                                                            {!! Form::hidden('testimony['.$i.'][is_with_attachment]', true, ['class'=>'form-control']) !!}
                                                                        @endif
                                                                        
                                                                    <td>
                                                                        {!! Form::text('testimony['.$i.'][name]', $row->name, ['class'=>'form-control']) !!}
                                                                        {!! Form::text('testimony['.$i.'][position]', $row->position, ['class'=>'form-control']) !!} 
                                                                        {!! Form::hidden('testimony['.$i.'][id]', $row->id, ['class'=>'form-control']) !!}
                                                                    </td>

                                                                     <td>
                                                                        
                                                                        @foreach($language_listing as $language_code => $language)
                                                                            @php
                                                                                   $img_path = 'img/flags/'.$language_code.'.png';
                                                                                   $content_data = isset($content_data_arr[$language]) ? $content_data_arr[$language] : '';
                                                                            @endphp
                                                                           <div class="input-group mb-3">
                                                                                <div class="input-group-prepend">
                                                                                    <span class="input-group-text"><img style='height:18px;width:auto;'class="media-object " src={{asset($img_path)}} alt=""></span>
                                                                                </div>
                                                                                {!! Form::textarea('testimony['.$i.'][content]['.$language.']', $content_data , ['class'=>'form-control','placeholder'=>ucfirst($language),'rows'=>5]) !!}
                                                                               
                                                                            </div>
                                                                        @endforeach
                                                                    </td>

                                                                     <td>

                                                                        {!! Form::select('testimony['.$i.'][rating]',App\Models\Setting::rating_combobox() , $row->rating, ['class'=>'form-control','autofocus']) !!}
                                                                        {!!Form::number('testimony['.$i.'][sort_order]', $row->sort_order, ['min'=>0,'step'=>'1', 'class'=>'form-control'])!!}
                                                                    </td>

                                                                    <td class="text-center">
                                                                        <a class="btn btn-default" onclick="remove_row(this);" href="javascript:void(0)"><i class="fa fa-trash fa-fw"></i></a>
                                                                    </td>
                                                                </tr>

                                                                @php $i ++ @endphp
                                                    @endforeach 

                                                    @if(count($listing) == 0) 
                                                            <tr>
                                                                <td>{{$i}}</td>
                                                                <td>
                                                                    {!!Form::file('cover_photo_path['.$i.']', array("class"=>"form-control dropify"))!!}
                                                                <td>
                                                                    {!! Form::text('testimony['.$i.'][name]', null, ['class'=>'form-control']) !!}
                                                                    {!! Form::text('testimony['.$i.'][position]', null, ['class'=>'form-control']) !!} 
                                                                </td>

                                                                 <td>
                                                                    @foreach($language_listing as $language)
                                                                       <div class="input-group mb-3">
                                                                            <div class="input-group-prepend">
                                                                                <span class="input-group-text"><i class="icon-clock"></i></span>
                                                                            </div>
                                                                            {!! Form::textarea('testimony['.$i.'][content]['.$language.']', null, ['class'=>'form-control','placeholder'=>ucfirst($language),'rows'=>5]) !!}
                                                                           
                                                                        </div>
                                                                    @endforeach
                                                                </td>

                                                                 <td>

                                                                    {!! Form::select('testimony['.$i.'][rating]',App\Models\Setting::rating_combobox() , null, ['class'=>'form-control','autofocus']) !!}
                                                                    {!!Form::number('testimony['.$i.'][sort_order]', null, ['min'=>0,'step'=>'1', 'class'=>'form-control'])!!}
                                                                </td>

                                                                <td class="text-center">
                                                                    <a class="btn btn-default" onclick="remove_row(this);" href="javascript:void(0)"><i class="fa fa-trash fa-fw"></i></a>
                                                                </td>
                                                            </tr>
                                                    @endif
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>


                    </div>
                </div>
                
            </div>
</div>
@include('_version_01.iot.layouts.partials._form_floating_footer_standard')
{!! Form::close() !!}
@endsection
@section('script')

@endsection